/***********************************************************************/
/*                                                                     */
/* MODULE NAME        DDESERV2.H                                       */
/*                                                                     */
/* DESCRIPTIVE NAME   DDE Server for CICS OS/2 ECI                     */
/*                                                                     */
/* Statement:         Sample Code - No Warranty Provided               */
/*                                                                     */
/*                    (c) Copyright IBM Corp. 1994.                    */
/*                                                                     */
/*                    All rights reserved.                             */
/*                                                                     */
/*                                                                     */
/* Status:            Version 1 Release 0                              */
/*                                                                     */
/*  NOTES :-                                                           */
/*    DEPENDENCIES = OS/2 V2.X                                         */
/*    RESTRICTIONS = none                                              */
/*    MODULE TYPE  = Source Header File                                */
/*    PROCESSOR    = PS/2 and PC                                       */
/*                                                                     */
/***********************************************************************/
/*                                                                     */
#define ID_MAINWND      256
#define ID_CALL_ECI     265
#define ID_EXITPROGRAM  270
#define ID_CLIENT       257
#define ID_LISTCLEAR    300
#define ID_NULL         -1

#define ECI_MSG         WM_USER + 10

#define THISAPPNAME     "DDESERV2"

/* Maximum values */

#define APP_MAX_SIZE     8    /* application name is DDESERV2 */
#define TOPIC_MAX_SIZE   8    /* Topic is always CICS program name */
#define ITEM_MAX_SIZE    255  /* Item is commarea to be passed. 256 will suffice */
#define CONV_MAX_COUNT   4    /* Max number of conversations */

/*************************************************************************/
/*   Function Prototypes                                                 */
/*************************************************************************/

int        main    ( VOID ) ;
FNWP       MainWindowProc ;
FNWP       DDEWindowProc ;
PFNWP      SystemListboxWindowProc ;

void ServerInitiate( HWND, MPARAM ) ;
void ServerTerminate( HWND, HWND ) ;
void ServerRequest( HWND, HWND, MPARAM ) ;
void SendData( HWND, HWND, CHAR *, BOOL ) ;
void SendTerminate( HWND , HWND ) ;
void TerminateConversations( void ) ;

short ECICall ( char *, HWND ) ;
short ECIRequestData ( void ) ;

BOOL AddConv( HWND, HWND, CHAR * ) ;
BOOL AddConvItem ( HWND, CHAR * ) ;
BOOL GetConvTopic ( HWND ) ;
BOOL GetConvItem ( HWND ) ;
BOOL AtLeastOneConvActive( void ) ;
HWND GetHwndDDEClient( HWND ) ;
HWND GetNextConv( HWND ) ;
BOOL IsConvInTerminateState( HWND ) ;
void RemoveConv( HWND ) ;
void SetConvInTerminateState( HWND ) ;
struct DDECONV * NEAR FindConv( HWND ) ;

void Info ( char *, ... ) ;
void Response ( char *, short) ;

/*************************************************************************/
/* Globals                                                               */
/*************************************************************************/

   HWND      hwndFrame ;             /* frame window handle             */
   HWND      hwndClient ;            /* client listbox window handle    */
   HWND      hwndDDEServer ;         /* child DDEServer window handle   */

   CHAR      szBuffer     [ 512 ] ;  /* for output string  to main window */
   CHAR      szCommArea   [ 256 ] ;  /* commarea to be passed on ECI call */

   CHAR      szItemName  [ITEM_MAX_SIZE+1] ;
   CHAR      szTopicName [TOPIC_MAX_SIZE+1] ;

   ECI_PARMS eci_parms ;             /* ECI Control block */

typedef struct DDECONV { HWND hwndDDEServer ;
                         HWND hwndDDEClient ;
                         CHAR szTopic [TOPIC_MAX_SIZE+1] ;
                         CHAR szItem  [ITEM_MAX_SIZE+1] ;
                         BOOL bInClientRequestedTerminate ;
};

struct DDECONV Conv[CONV_MAX_COUNT] ;
int    nConvCount = 0 ;

